// GENERAL STYLES USED BY MULTIPLE ELEMENTS

.vheight-100 {
  height: 100vh;
}

.height-100,
.is-height-100 {
  height: 100%;
}

.width-100 {
  width: 100%;
}

.width-content {
  min-width: fit-content;
}

.is-scroll {
  overflow: auto;
}

.is-absolute-vcenter {
  position: absolute;
  margin: auto;
  top: 0;
  left: -1px;
  bottom: 0;
}

.is-clipped-container {
  @extend .is-clipped;
  @extend .height-100;
}

.is-scroll-container {
  @extend .is-scroll;
  @extend .height-100;
}

.is-layer-10 {
  z-index: 10;
}

.is-layer-top {
  z-index: 100;
}

.has-border {
  border: 1px solid black;
}

.has-border-top {
  border-top: 1px solid black;
}

.has-border-right {
  border-right: 1px solid black;
}

.has-border-bottom {
  border-bottom: 1px solid black;
}

.has-border-left {
  border-left: 1px solid black;
}

.has-no-outline {
  outline: none;
  border: none !important;
}

.has-no-shadow {
  box-shadow: none !important;
  text-shadow: none !important;
}

.has-overflow-ellipsis {
  text-overflow: ellipsis;
  white-space: nowrap;
}

.is-interactive {
  &:hover {
    cursor: pointer;
    filter: brightness(110%);
  }
}

.is-interactive-2 {
  @extend .is-cursor-pointer;
  position: relative;

  &:after {
    content: "";
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    display: block;
    border-radius: 5px;
    pointer-events: none;
  }

  &:hover {
    background-color: rgba(0, 0, 0, 0.05);

    &:after {
      background: rgba(217, 217, 217, 0.2);
      box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.1);
    }
  }
}

.is-cursor-pointer {
  cursor: pointer;
}

.is-cursor-default {
  cursor: default !important;
  cursor: auto !important;
}

.is-grabbable {
  // fallback if grab cursor is unsupported
  cursor: move;
  cursor: grab;
  cursor: -moz-grab;
  cursor: -webkit-grab;
}

.has-text-pre-wrap {
  white-space: pre-wrap;
}

.has-text-lines-1 {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 1;
  line-clamp: 1;
  -webkit-box-orient: vertical;
}

.has-text-lines-2 {
  @extend .has-text-lines-1;
  -webkit-line-clamp: 2;
  line-clamp: 2;
}

.has-text-lines-3 {
  @extend .has-text-lines-1;
  -webkit-line-clamp: 3;
  line-clamp: 3;
}

.has-text-lines-5 {
  @extend .has-text-lines-1;
  -webkit-line-clamp: 5;
  line-clamp: 5;
}

.has-plugin-style {
  &.logic {
    @extend .has-background-green-4;

    &.light {
      @extend .has-background-green-5;
    }
  }

  &.time {
    @extend .has-background-orange-4;

    &.light {
      @extend .has-background-orange-5;
    }
  }

  &.data {
    @extend .has-background-yellow-4;

    &.light {
      @extend .has-background-yellow-5;
    }
  }

  &.control {
    @extend .has-background-purple-4;

    &.light {
      @extend .has-background-purple-5;
    }
  }

  &.telegram {
    @extend .has-background-blue-4;

    &.light {
      @extend .has-background-blue-5;
    }
  }

  &.twilio {
    @extend .has-background-blue-4;

    &.light {
      @extend .has-background-blue-5;
    }
  }

  &.mqtt {
    @extend .has-background-blue-3;

    &.light {
      @extend .has-background-blue-4;
    }
  }

  &.default {
    @extend .has-background-blue-4;
    @extend .has-text-black;

    &.light {
      @extend .has-background-blue-5;
    }
  }
}